#include <stdio.h>
#include <math.h>

//
//    evaluates a certain integral related to Stefan's constant
//    using Guass-Laguerre integration
//    input: 1) file with parameters related to integration
//           2) order of Laguerre polynomial
//    reports numerical value of integral and absoulte relative error
//    (exact value of integral is known analytically)
//

int main()
{
  double x, w1, w2, exact, sum;
  int i, n, kdumb;

  char filename[32];
  char header[128];

  FILE* file;

  printf("File containing zeros and weights\n");
  scanf("%32s", filename);

  file = fopen(filename, "r");

  printf("Number of zeros\n");
  scanf("%i", &n);

  sum = 0;

  fgets(header, 128, file);

  for(i=0; i<n; i++)
  {
    // remember to use lf ("long float") if your data are double
    fscanf(file, "%i\t%lf\t%lf\t%lf", &kdumb, &x, &w1, &w2);
    sum += x;
  }

  exact = pow(M_PI, 4) / 15.0;

  printf("%i %E %E\n", n, sum, fabs(sum-exact)/exact);

  fclose(file);
  return 0;
}

